;; Eval or load this script and execute the `linefield-example' command
;; for demonstration of the field boundary misbehaviors in an emacs 22 cvs
;; checkout as of mid-day (EST), October 9, 2006.

;; ken
;; ken.manheimer@gmail.com
;; http://myriadicity.net

(defvar linefield-text
  "The lines with a '|' bar as their first non-whitespace
character are decorated with 'field 'boundary and 'face
'highlight text properties from the left margin until and
including the bar.

 | I've lost track of what the correct behavior is supposed to be.
  | When the cursor first changes fields while moving downwards,
   | it jumps to the first column.
    | It moves back to its original column for subsequent moves.
   | If the content side has its own field setting
   | (see the commented out code), then the cursor shifts
  |  to the last column when moviing upwards
 | and hitting a field shift.

The jumps to the first or last column seem undesirable to me."

  "Text for demonstrating linefield staircase.")

(defun linefield-example ()
  "Demonstrate fieldtext boundary misbehavior."
  (interactive)
  (let* ((buffer (get-buffer-create "linefield-example"))
         first second
         (inhibit-field-text-motion t))
    (pop-to-buffer buffer)
    (erase-buffer)
    (insert linefield-text)
    (goto-char (point-min))
    (while (re-search-forward "^ +|" nil t)
      (cond ((not first) (setq first (point)))
            ((not second) (setq second (point))))
      (set-text-properties (match-beginning 0) (point)
                           '(field structure face highlight))
;;      (set-text-properties (point) (progn (end-of-line) (point))
;;                           '(field content face bold))
      )
    (goto-char second)))
